summaryrefslogtreecommitdiffstats
path: root/usr.bin/man
diff options
context:
space:
mode:
authorsbruno <sbruno@FreeBSD.org>2015-02-13 00:29:57 +0000
committersbruno <sbruno@FreeBSD.org>2015-02-13 00:29:57 +0000
commit538802789a529fb5850e4d2625c62f36c1b0e2f1 (patch)
treed0eec84147dc302e2a17fd024c99ad62a4bd538b /usr.bin/man
parent914dd97ca51bfe6301ae8bd78c4d92aec1e8aa48 (diff)
downloadFreeBSD-src-538802789a529fb5850e4d2625c62f36c1b0e2f1.zip
FreeBSD-src-538802789a529fb5850e4d2625c62f36c1b0e2f1.tar.gz
MFC 272315 272757 274091 274902
r272315 Explicitly return None for negative event indices. Prior to this, eventat(-1) would return the next-to-last event causing the back button to cycle back to the end of an event source instead of stopping at the start. r272757 Add schedgraph traces for callout handlers. Specifically, a callwheel logs a running event each time it executes a callout function. The event includes the function pointer, argument, and whether or not it was run from hardware interrupt context. The callwheel is marked idle when each handler completes. This effectively logs the duration of each callout routine in the graph. r274091 Bind Ctrl-Q as a global hotkey to exit. Bind Ctrl-W as a hotkey to close dialogs. r274902 Add a new thread state "spinning" to schedgraph and add tracepoints at the start and stop of spinning waits in lock primitives. Reviewed by: jhb
Diffstat (limited to 'usr.bin/man')
-rwxr-xr-xusr.bin/man/man.sh48
1 files changed, 44 insertions, 4 deletions
diff --git a/usr.bin/man/man.sh b/usr.bin/man/man.sh
index 0f6249a..ac66eec 100755
--- a/usr.bin/man/man.sh
+++ b/usr.bin/man/man.sh
@@ -276,11 +276,8 @@ man_check_for_so() {
return 0
}
-# Usage: man_display_page
-# Display either the manpage or catpage depending on the use_cat variable
man_display_page() {
- local EQN NROFF PIC TBL TROFF REFER VGRIND
- local IFS l nroff_dev pipeline preproc_arg tool
+ local IFS pipeline preconv_enc testline
# We are called with IFS set to colon. This causes really weird
# things to happen for the variables that have spaces in them.
@@ -312,6 +309,49 @@ man_display_page() {
return
fi
+ case "${manpage}" in
+ *.${man_charset}/*)
+ case "$man_charset" in
+ ISO8859-1) preconv_enc="latin-1" ;;
+ ISO8859-15) preconv_enc="latin-1" ;;
+ UTF-8) preconv_enc="utf-8" ;;
+ esac
+ ;;
+ esac
+
+ if [ -n "$preconv_enc" ]; then
+ pipeline="preconv -e $preconv_enc |"
+ fi
+ testline="$pipeline mandoc -Tlint -Werror 2>/dev/null"
+ pipeline="$pipeline mandoc -Tlocale | $MANPAGER"
+
+ if ! eval "$cattool $manpage | $testline" ;then
+ if which -s groff2; then
+ man_display_page_groff
+ else
+ echo "This manpage needs groff(1) to be rendered" >&2
+ echo "First install groff(1): " >&2
+ echo "pkg install groff " >&2
+ ret=1
+ fi
+ return
+ fi
+
+ if [ $debug -gt 0 ]; then
+ decho "Command: $cattool $manpage | $pipeline"
+ ret=0
+ else
+ eval "$cattool $manpage | $pipeline"
+ ret=$?
+ fi
+}
+
+# Usage: man_display_page
+# Display either the manpage or catpage depending on the use_cat variable
+man_display_page_groff() {
+ local EQN NROFF PIC TBL TROFF REFER VGRIND
+ local IFS l nroff_dev pipeline preproc_arg tool
+
# So, we really do need to parse the manpage. First, figure out the
# device flag (-T) we have to pass to eqn(1) and groff(1). Then,
# setup the pipeline of commands based on the user's request.
OpenPOWER on IntegriCloud